<?php
  ///////////////////////////////////////////////////
  // Система учёта посещаемости сайта - PowerCounter
  // 2003-2006 (C) IT-студия SoftTime (http://www.softtime.ru)
  // Поддержка: http://www.softtime.ru/forum/
  // Симдянов И.В. (simdyanov@softtime.ru)
  // Левин А.В. (loki_angel@mail.ru)
  // Кузнецов М.В. (kuznetsov@softtime.ru)
  // Голышев С.В. (softtime@softtime.ru)
  ///////////////////////////////////////////////////
  // Выставляем уровень обработки ошибок (http://www.softtime.ru/info/articlephp.php?id_article=23)
  Error_Reporting(E_ALL & ~E_NOTICE); 

// Функция архивации роботов в суточные таблицы
function archive_robots($tbl_ip, $tbl_arch_robots)
{
  // Получаем дату начала регистрации данных и число прошедших с начала регистрации
  $dat = mysql_query("SELECT UNIX_TIMESTAMP(MIN(putdate)) AS data FROM $tbl_ip");
  if (!$dat) exit(mysql_error());
  $arr_date = mysql_fetch_array($dat);
  //Последнее полный день
  $last_day = mktime(23,59,59, date("m"), date("d")-1, date("Y"));
  // получаем последнюю дату архивации
  $query = "SELECT UNIX_TIMESTAMP(MAX(putdate)) FROM $tbl_arch_robots";
  $arh = mysql_query($query);
  if(mysql_num_rows($arh) > 0)
  {
    $last_date = mysql_result($arh,0);
  }
  if(empty($last_date))
  {
    if(isset($arr_date['data']))
    {
      // Если запуск первый - берём дату из $tbl_ip 
      $last_date = $arr_date['data'];
    }
    else
    {
      // Иначе берём текущие сутки
      $last_date = time();
    }
  }
  //блок архивации
  if (ceil(($last_day - $last_date)/24/60/60))
  {
    $days = ceil(($last_day-$last_date)/24/60/60);
    for ($i = $days; $i>0; $i--)
    {
      // Вспомогательное условие
      $tmp = "putdate < '".date("Y-m-d H:i:s",$last_day)."' - INTERVAL ".($i-1)." DAY AND
              putdate >= '".date("Y-m-d H:i:s",$last_day)."' - INTERVAL $i DAY";

      // Извлекаем число роботов Yandex
      $query_systems_yandex = "SELECT COUNT(*) FROM $tbl_ip WHERE systems = 'robot_yandex' AND ".$tmp;
      // Извлекаем число роботов Google
      $query_systems_google = "SELECT COUNT(*) FROM $tbl_ip WHERE systems = 'robot_google' AND ".$tmp;
      // Извлекаем число роботов Rambler
      $query_systems_rambler = "SELECT COUNT(*) FROM $tbl_ip WHERE systems = 'robot_rambler' AND ".$tmp;
      // Извлекаем число роботов Aport
      $query_systems_aport = "SELECT COUNT(*) FROM $tbl_ip WHERE systems = 'robot_aport' AND ".$tmp;
      // Извлекаем число роботов MSN
      $query_systems_msn = "SELECT COUNT(*) FROM $tbl_ip WHERE systems = 'robot_msnbot' AND ".$tmp;
        // Извлекаем число роботов none
      $query_systems_none = "SELECT COUNT(*) FROM $tbl_ip WHERE systems = 'none' AND ".$tmp;

      $ynd = mysql_query($query_systems_yandex);
      if(!$ynd) exit(mysql_error());
      $gog = mysql_query($query_systems_google);
      if(!$gog) exit(mysql_error());
      $ram = mysql_query($query_systems_rambler);
      if(!$ram) exit(mysql_error());
      $apt = mysql_query($query_systems_aport);
      if(!$apt) exit(mysql_error());
      $msn = mysql_query($query_systems_msn);
      if(!$msn) exit(mysql_error());
        $non = mysql_query($query_systems_none);
      if(!$non) exit(mysql_error());

      $systems_yandex    = mysql_result($ynd, 0);
      $systems_gogle     = mysql_result($gog, 0);
      $systems_rambler   = mysql_result($ram, 0);
      $systems_aport     = mysql_result($apt, 0);
      $systems_msn       = mysql_result($msn, 0);
        $systems_none      = mysql_result($non, 0);

      $sql_robots[] = "(NULL,
                        '".date("Y-m-d H:i:s",$last_day)."' - INTERVAL ".($i-1)." DAY,
                        $systems_yandex,
                        $systems_rambler,
                        $systems_gogle,
                        $systems_aport,
                        $systems_msn,
                                $systems_none)";
    }
    if(!empty($sql_robots))
    {
      $query = "INSERT INTO $tbl_arch_robots VALUES".implode(",", $sql_robots);
      if(!mysql_query($query)) exit("ip3".mysql_error());
    }
  }
}

// Функция архивации роботов в недельные таблицы
function archive_robots_week($tbl_arch_robots, $tbl_arch_robots_week)
{
  // Получаем дату начала регистрации данных и число прошедших с начала регистрации дней
  $dat = mysql_query("SELECT UNIX_TIMESTAMP(MIN(putdate)) AS data FROM $tbl_arch_robots");
  if (!$dat) exit("date_week_client1 ".mysql_error());
  $arr_date = mysql_fetch_array($dat);

  // получаем последнюю дату архивации
  $query = "SELECT UNIX_TIMESTAMP(MAX(putdate_end)) FROM $tbl_arch_robots_week";
  $arh = mysql_query($query);
  if(!$arh) exit("date_week_client2 ".mysql_error());
  if(mysql_num_rows($arh) > 0)
  {
    $last_date = mysql_result($arh,0);
  }
  if(empty($last_date))
  {
    if(isset($arr_date['data']))
    {
      // Если запуск первый - берём дату из $tbl_ip 
      $last_date = $arr_date['data'];
    }
    else
    {
      // Иначе берём текущие сутки
      $last_date = time();
    }
  }

  //Последней полный день
  $last_day = mktime(23,59,59, date("m"), date("d")-1, date("Y"));
  // Вычисляем сколько недель прошло с даты последней архивации
  $week = floor(($last_day - $last_date)/24/60/60/7); 

  // Если прошло больше недели - архивируем данные
  if ($week > 0)
  {
    // $last_date - дата последней архивации... - смотрим далеко ли до
    // конца недели (воскресенье). Интервал включает данные с Понедельника (1)
    // до воскресенья (0).
    $weekday = date('w',$last_date);
    // Делаем так, чтобы воскресенье было 7, а понедельник 1
    // if($weekday === 0) $weekday = 7;

    // Текущему времени приравниваем начальную точку
    $current_date = $last_date;
    while(floor(($last_day - $current_date)/24/60/60/7))
    {
      // Вспомогательное условие
      $tmp = "putdate > '".date("Y-m-d 23:59:59", $current_date)."' AND
              putdate <= '" .date("Y-m-d 23:59:59", $current_date + 24*3600*(7 - $weekday))."'";

      // Извлекаем число роботов Yandex
      $query_systems_yandex = "SELECT SUM(yandex) FROM $tbl_arch_robots WHERE ".$tmp;
      // Извлекаем число роботов Google
      $query_systems_google = "SELECT SUM(google) FROM $tbl_arch_robots WHERE ".$tmp;
      // Извлекаем число роботов Rambler
      $query_systems_rambler = "SELECT SUM(rambler) FROM $tbl_arch_robots WHERE ".$tmp;
      // Извлекаем число роботов Aport
      $query_systems_aport = "SELECT SUM(aport) FROM $tbl_arch_robots WHERE ".$tmp;
      // Извлекаем число роботов MSN
      $query_systems_msn = "SELECT SUM(msn) FROM $tbl_arch_robots WHERE ".$tmp;
        // Извлекаем число роботов none
      $query_systems_none = "SELECT SUM(none) FROM $tbl_arch_robots WHERE ".$tmp;

      $ynd = mysql_query($query_systems_yandex);
      if(!$ynd) exit("week_robot_yandex ".mysql_error());
      $gog = mysql_query($query_systems_google);
      if(!$gog) exit(mysql_error());
      $ram = mysql_query($query_systems_rambler);
      if(!$ram) exit(mysql_error());
      $apt = mysql_query($query_systems_aport);
      if(!$apt) exit(mysql_error());
      $msn = mysql_query($query_systems_msn);
      if(!$msn) exit(mysql_error());
        $non = mysql_query($query_systems_none);
      if(!$non) exit(mysql_error());

      $systems_yandex    = mysql_result($ynd, 0);
      $systems_gogle     = mysql_result($gog, 0);
      $systems_rambler   = mysql_result($ram, 0);
      $systems_aport     = mysql_result($apt, 0);
      $systems_msn       = mysql_result($msn, 0);
        $systems_none      = mysql_result($non, 0);

      $sql_robots[] = "(NULL,
                        '".date("Y-m-d 23:59:59", $current_date)."',
                        '".date("Y-m-d 23:59:59", $current_date + 24*3600*(7 - $weekday))."', 
                        $systems_yandex,
                        $systems_rambler,
                        $systems_gogle,
                        $systems_aport,
                        $systems_msn,
                                $systems_none)";

      // Увеличиваем текущее время до следующей недели
      $current_date += (7 - $weekday)*24*3600;
      $weekday = 0; // Далее идут циклы по целой недели
    }
    if(!empty($sql_robots))
    {
      $query = "INSERT INTO $tbl_arch_robots_week VALUES".implode(",", $sql_robots);
      if(!mysql_query($query)) exit($query.mysql_error());
    }
  }
}


// Функция архивации роботов поисковых систем в месячные таблицы
function archive_robots_month($tbl_arch_robots, $tbl_arch_robots_month)
{
  // Получаем дату начала регистрации данных и число прошедших с начала регистрации дней
  $dat = mysql_query("SELECT UNIX_TIMESTAMP(MIN(putdate)) AS data
                      FROM $tbl_arch_robots");
  if (!$dat) exit(mysql_error());
  $arr_date = mysql_fetch_array($dat);

  // получаем последнюю дату архивации
  $query = "SELECT UNIX_TIMESTAMP(MAX(putdate + INTERVAL 1 MONTH)) 
            FROM $tbl_arch_robots_month";
  $arh = mysql_query($query);
  if(!$arh) exit(mysql_error());
  if(mysql_num_rows($arh) > 0)
  {
    $last_date = mysql_result($arh,0);
  }
  if(empty($last_date))
  {
    if(isset($arr_date['data']))
    {
      // Если запуск первый - берём дату из $tbl_arch_robots
      $last_date = $arr_date['data'];
    }
    else
    {
      // Иначе берём текущие сутки
      $last_date = time();
    }
  }

  //Последней полный день
  $last_day = mktime(23,59,59, date("m"), date("d")-1, date("Y")) + 2;
  // Вычисляем сколько полных месяцев прошло с даты последней архивации
  $month = (floor(date("Y",$last_day) - date("Y",$last_date)))*12 + 
           floor(date("m",$last_day) - date("m",$last_date)); 

  // Если прошло больше месяца - архивируем данные
  if ($month > 0)
  {
    // Архивируем данные по всем месяцам, по которым архивация
    // не проводилась
    for($i = date("Y",$last_date)*12 + date("m",$last_date); $i < date("Y",$last_day)*12 + date("m",$last_day); $i++)
    {
      $year = (int)($i/12);
      $month = ($i%12);
      if($month == 0)
      {
        $year--;
        $month = 12;
      }
      // Вспомогательное условие
      $tmp = "YEAR(putdate) = $year AND
              MONTH(putdate) = '".sprintf("%02d",$month)."'";

      // Извлекаем число роботов Yandex
      $query_systems_yandex = "SELECT SUM(yandex) FROM $tbl_arch_robots WHERE ".$tmp;
      // Извлекаем число роботов Google
      $query_systems_google = "SELECT SUM(google) FROM $tbl_arch_robots WHERE ".$tmp;
      // Извлекаем число роботов Rambler
      $query_systems_rambler = "SELECT SUM(rambler) FROM $tbl_arch_robots WHERE ".$tmp;
      // Извлекаем число роботов Aport
      $query_systems_aport = "SELECT SUM(aport) FROM $tbl_arch_robots WHERE ".$tmp;
      // Извлекаем число роботов MSN
      $query_systems_msn = "SELECT SUM(msn) FROM $tbl_arch_robots WHERE ".$tmp;
        // Извлекаем число роботов none
      $query_systems_none = "SELECT SUM(none) FROM $tbl_arch_robots WHERE ".$tmp;

      $ynd = mysql_query($query_systems_yandex);
      if(!$ynd) exit("week_robot_yandex ".mysql_error());
      $gog = mysql_query($query_systems_google);
      if(!$gog) exit(mysql_error());
      $ram = mysql_query($query_systems_rambler);
      if(!$ram) exit(mysql_error());
      $apt = mysql_query($query_systems_aport);
      if(!$apt) exit(mysql_error());
      $msn = mysql_query($query_systems_msn);
      if(!$msn) exit(mysql_error());
        $non = mysql_query($query_systems_none);
      if(!$non) exit(mysql_error());

      $systems_yandex    = mysql_result($ynd, 0);
      $systems_gogle     = mysql_result($gog, 0);
      $systems_rambler   = mysql_result($ram, 0);
      $systems_aport     = mysql_result($apt, 0);
      $systems_msn       = mysql_result($msn, 0);
        $systems_none      = mysql_result($non, 0);

      $sql_robots[] = "(NULL,
                       '$year-".sprintf("%02d",$month)."-01 23:59:59',
                        $systems_yandex,
                        $systems_rambler,
                        $systems_gogle,
                        $systems_aport,
                        $systems_msn,
                                $systems_none)";

    }

    if(!empty($sql_robots))
    {
      $query = "INSERT INTO $tbl_arch_robots_month VALUES".implode(",", $sql_robots);
      if(!mysql_query($query)) exit($query.mysql_error());
    }
  }
}
?>
